"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupConcat = void 0;
const Helpers_1 = require("../functions/Helpers");
const Aggregator_1 = require("./Aggregator");
class GroupConcat extends Aggregator_1.AggregatorComponent {
    constructor() {
        super(...arguments);
        this.state = undefined;
    }
    static emptyValue() {
        return (0, Helpers_1.string)('').toRDF();
    }
    put(term) {
        if (this.state === undefined) {
            this.state = term.value;
        }
        else {
            this.state += this.separator + term.value;
        }
    }
    result() {
        if (this.state === undefined) {
            return GroupConcat.emptyValue();
        }
        return (0, Helpers_1.string)(this.state).toRDF();
    }
}
exports.GroupConcat = GroupConcat;
//# sourceMappingURL=GroupConcat.js.map