"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Max = void 0;
const Aggregator_1 = require("./Aggregator");
class Max extends Aggregator_1.AggregatorComponent {
    constructor() {
        super(...arguments);
        this.state = undefined;
    }
    put(term) {
        if (this.state === undefined) {
            const { value } = this.extractValue(term);
            this.state = { extremeValue: value, term };
        }
        else {
            const extracted = this.extractValue(term);
            if (extracted.value > this.state.extremeValue) {
                this.state = {
                    extremeValue: extracted.value,
                    term,
                };
            }
        }
    }
    result() {
        if (this.state === undefined) {
            return Max.emptyValue();
        }
        return this.state.term;
    }
}
exports.Max = Max;
//# sourceMappingURL=Max.js.map